#[test]
fn test_emit() {
    use crate::compiler::*;
    use crate::parser::*;
    use crate::compiler::backend::*;
    let src = "
(module Shader Logical GLSL450)
(import :std GLSL.std.450)
(bind (frag-coord:*v4f32i) (BuiltIn FragCoord))
(bind (out-color:*v4f32o) (Location 0))
(dec frag-coord:*v4f32i Input)
(dec out-color:*v4f32o Output)
(entry main Fragment OriginUpperLeft (:frag-coord :out-color))
(fun (main)
  (store-ptr (out-color)
    (v4f32i (/ (.xy (load-ptr frag-coord))
               (v2f32 1920.0 1080.0)) 
            1.0 
            1.0)))
";
    let mut ast = parse(tokenize(src));
    let module = meta_compile(&mut ast);
    let res = spirv_meta(module);
    println!("{}", res);
}